<?php

namespace Repository;

use Util\InstanceProvider;
use Teknisa\Model\Traits\TQuery;

class Comments 
{
    use TQuery;

    public function getCommentsOfTaskExceptCommentedBy($issueId) {
        $query = "
            SELECT *
              FROM (SELECT C.ID, C.ORGANIZATION, C.DESCRIPTION, C.TASK ,
                           TO_CHAR(C.CREATED_AT, 'DD/MM/YYYY HH24:MI:SS') AS CREATED_AT,
                           'Criado dia '||TO_CHAR(C.CREATED_AT, 'DD/MON/YYYY ','NLS_LANGUAGE = BRAZILIAN PORTUGUESE')||' por '||R.NAME AS NAME,
                           TO_CHAR(C.CREATED_AT, 'YYYYMMDDHHMISS') AS ORDERBY
                      FROM COMMENTS C
                 LEFT JOIN RESOURCE_T R ON(R.ID = C.CREATED_BY)
                     WHERE C.TASK = :TASK_ID)
          ORDER BY ORDERBY DESC";

        $params = array(
            'TASK_ID' => $issueId
        );
        
        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $params);
    }

    public function getProductCallCommentsFromSolicitacao($nrSoliServ)
    {
        $query = <<<SQL
            SELECT *
              FROM (SELECT OP.NMOPERADOR||' '||LFT.TXACAOLFTRAM||' em '|| TO_CHAR(LFT.DTALFASETRAM, 'DD/MON/YYYY','NLS_LANGUAGE = BRAZILIAN PORTUGUESE') ||' e encaminhou para '||OPR.NMOPERADOR AS NAME,
                           LFT.DSALFASETRAM AS DESCRIPTION,LFT.CDFASETRAM,
                           TO_CHAR(LFT.DTALFASETRAM, 'DD/MM/YYYY HH24:MI:SS') AS CREATED_AT, TO_CHAR(LFT.DTALFASETRAM, 'YYYYMMDDHH24MISS') AS ORDERBY
                      FROM LOGFASETRAM LFT
                 LEFT JOIN OPERADOR OP  ON OP.CDOPERADOR  = LFT.CDOPERADOR
                 LEFT JOIN OPERADOR OPR ON OPR.CDOPERADOR = LFT.CDOPERRESP
                INNER JOIN SOLISERV SOL ON SOL.NRSOLISERV = :NRSOLISERV
                     WHERE LFT.NRSOLISERV = :NRSOLISERV
                   )
          ORDER BY ORDERBY DESC
SQL;

        $params = array (
            "NRSOLISERV"    => $nrSoliServ
        );
        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $params);
    }

    public function FindDocumentsTemplate($nrorg)
    {

        $query = <<<SQL
        SELECT * FROM (
        SELECT DOC.ID, DOC.NAME ,DOC.TYPE ,ATT.LABEL ,DOC.CREATED_AT ,RES.NAME AS CREATED_BY, ATT.ID AS ATTACHMENT_ID
          FROM DOCUMENT_TEMPLATE DOC
          JOIN ATTACHMENT ATT ON (ATT.ID = DOC.ATTACHMENT)
		  JOIN RESOURCE_T RES ON (DOC.UPDATED_BY = RES.ID)
          WHERE DOC.ORGANIZATION_ID = :organizationId
			   )
			   WHERE 1 = 1
SQL;

        $params = array(
            "organizationId" => $nrorg
        );    
        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $params);
    }
}