<?php


namespace Service;

use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use \Util\Utilities;
use Repository\Project as ProjectRepository;

class Project
{
    const PROJECT_TYPE_PRODUCT = Entities\Project::PROJECT_TYPE_PRODUCT;

    /**
     * @var ProjectRepository
     */
    private $projectRepository;
    /**
     * @var Utilities
     */
    private $environment;

    public function __construct(ProjectRepository $projectRepository)
    {
        $this->environment = InstanceProvider::getEnvironment();
        $this->projectRepository = $projectRepository;
    }

    public static function getProductProject(Entities\Project $project = null)
    {
        $productProject = null;
        if ($project) {
            if ($project->getProjectType()->getExternaltype() == self::PROJECT_TYPE_PRODUCT) {
                $productProject = $project;
            } else {
                $productProject = self::getProductProject($project->getParent());
            }
        }
        return $productProject;
    }

    /**
     * @return array
     */
    public function findProjectsByOperador(): array
    {
        return $this->projectRepository->findProjectsByOperador(getResourceId());
    }

    public function findModelProjectForFilterTaskTracking()
    {
        $organizationId = $this->environment->getCurrentOrganizationId();
        $userId = $this->environment->getCurrentUserId();
        $projects = InstanceProvider::getRepository()->getLocalProject()->modelProjectForFilterTaskTracking($organizationId,$userId);
        return $projects;
    }

}
