/* Tabela AJCTRECEBER : Ajuste de Conta a Receber */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabelaAJCTRECEBER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela ajuste de Conta a Receber,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_AJCTRECEBER
AFTER DELETE OR INSERT OR UPDATE
ON AJCTRECEBER FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
BEGIN
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO   := '3';
      V_DESC   := 'Dt. Ajuste '   || TO_CHAR(:OLD.DTAJUSTEREC, 'DD/MM/YYYY') ||
                  ' Valor '       || TO_CHAR(:OLD.VRAJUSTEREC)               ||
                  ' Codigo '      || :OLD.CDAJUCTREC                         ||
                  ' Descricao '   || :OLD.DSAJUSTEREC                        ||
                  ' Parcelas '    || :OLD.NRPARCELAREC                       ||
                  ' NrseqVenc '   || :OLD.NRSEQVENREC;
      V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANCTONF;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANCTONF;
         V_CDFILLOGOPER := :OLD.CDFILIAL;

       	 IF   (:NEW.CDFILIAL     <> :OLD.CDFILIAL    )  OR
               (:NEW.NRLANCTONF   <> :OLD.NRLANCTONF  )  OR
               (:NEW.DTAJUSTEREC  <> :OLD.DTAJUSTEREC )  OR
               (:NEW.VRAJUSTEREC  <> :OLD.VRAJUSTEREC )  OR
               (:NEW.CDAJUCTREC   <> :OLD.CDAJUCTREC  )  OR
               (:NEW.DSAJUSTEREC  <> :OLD.DSAJUSTEREC )  OR
               (:NEW.NRSEQVENREC  <> :OLD.NRSEQVENREC )  OR
               (:NEW.NRPARCELAREC <> :OLD.NRPARCELAREC)  THEN
               V_TIPO   := '2';
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRLANCTONF;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC   := 'Dt. Ajuste '   || TO_CHAR(:NEW.DTAJUSTEREC, 'DD/MM/YYYY') ||
                  ' Valor '       || TO_CHAR(:NEW.VRAJUSTEREC)               ||
                  ' Codigo '      || :NEW.CDAJUCTREC                         ||
                  ' Descricao '   || :NEW.DSAJUSTEREC                        ||
                  ' parcelas '    || :NEW.NRPARCELAREC                       ||
                  ' NrseqVenc '   || :NEW.NRSEQVENREC ;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER,
                DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('AJCTRECEBER', V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_AJCTRECEBER','4.11.128'); END;
/

