/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IMPO                                                     */
/* Tabela : IMPOSTO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_IMPO'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_IMPO
GO

CREATE TRIGGER DTULTATU_IMPO
ON IMPOSTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'IMPOSTO', null, 'CDIMPOSTO='+ CDIMPOSTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE IMPOSTO
      SET DTULTATUIMPO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(IMPOSTO.CDIMPOSTO,0)    = ISNULL(INSERTED.CDIMPOSTO,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_IMPO','5.75.XXX';
GO

