/* Sistemas Integrados TECNISA
   Servios

Nome: COMP_LOCAL

Descrio:
   Verifica se o produto utiliza composio local ou padro.
Criao:
28/07/05 - Welbert G. Moitinha

Converso:
30/08/2005 - Hudson Magno*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'COMP_LOCAL' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION COMP_LOCAL
GO

CREATE FUNCTION COMP_LOCAL ( @P_CDFILIAL     VARCHAR(4),
                             @P_CDPRODUTO    VARCHAR(10)
                           ) RETURNS VARCHAR(4)

AS
BEGIN
   DECLARE @V_CTREG INTEGER;
   DECLARE @V_IDLOCAL VARCHAR(04);

   SELECT @V_CTREG = COUNT(*)
   FROM
      ROTFABLOCAL
   WHERE(CDFILIAL  = @P_CDFILIAL ) AND
        (CDPRODUTO = @P_CDPRODUTO);

   IF @V_CTREG > 0 BEGIN
      SET @V_IDLOCAL = @P_CDFILIAL;
   END
   ELSE BEGIN
      SELECT @V_CTREG = COUNT(*)
      FROM
         ROTFABRICA
      WHERE
         (CDPRODUTO = @P_CDPRODUTO);

      IF @V_CTREG > 0 BEGIN
         SET @V_IDLOCAL = 'P';
      END
      ELSE BEGIN
         SET @V_IDLOCAL = 'N';
      END;
   END;
   RETURN(@V_IDLOCAL);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'COMP_LOCAL','5.05.007';
GO

