import { AlertServiceCustom } from '@/services/AlertServiceCustom';
import { InstanceService } from '@/services/InstanceService';
import { LoadingService } from '@zeedhi/common';
import { Http } from '@zeedhi/core';
import Messages from '@/services/Messages';

export class DMBudgetIssueClosedController {
	public callRelationshiClosed = '';

    public callTypeClosed = 'I';

    private validateEditBudgetClosed = true;

	public async changeTabBudgetIssueClosed(params: any) {
		try {
			this.callRelationshiClosed = params.component.events.callRelationship();
			const tabBudgetIssueClosed = InstanceService.getInstanceTabs('tabBudgetIssueClosed');
			const tab = tabBudgetIssueClosed.tabs[tabBudgetIssueClosed.activeTab];
			setTimeout(async () => {
				if (tab.events && tab.events.change && typeof tab.events.change === 'function') {
					await tab.events.change(params);
				}
			}, 100);
		} catch (e) {
			setTimeout(async () => {
				await this.changeTabBudgetIssueClosed(params);
			}, 1000);
		}
	}

    public async changeTabFrameBudgetItensIssueClosed() {
		LoadingService.show();
		try {
			const budgetItensGridClosedInstance = InstanceService.getInstanceTekGrid('gridbudgetItensIssueClosed');
			const formMaintenanceCostIssueClosed = InstanceService.getInstanceZdForm('formMaintenanceCostIssueClosed');
			formMaintenanceCostIssueClosed.children.forEach((row) => {
				formMaintenanceCostIssueClosed.value[row.name] = 0;
			});
			budgetItensGridClosedInstance.datasource.get();
			const response = await Http.post('/maintenanceCost', {
				CALL_RELATIONSHIP: this.callRelationshiClosed,
				CALL_TYPE: this.callTypeClosed,
			});
			formMaintenanceCostIssueClosed.children.forEach((row) => {
				if (response && response.data && response.data.data && response.data.data[row.name]) {
					formMaintenanceCostIssueClosed.value[row.name] = response.data.data[row.name];
				} else {
					formMaintenanceCostIssueClosed.value[row.name] = 0;
				}
			});
			formMaintenanceCostIssueClosed.value.changed = false;
			formMaintenanceCostIssueClosed.value.ISSUE_ID = this.callRelationshiClosed;
			this.validateEditBudgetClosed = !!formMaintenanceCostIssueClosed.value.VALIDATE_EDIT;
			if (!formMaintenanceCostIssueClosed.value.VALIDATE_EDIT) {
				AlertServiceCustom.customErrorAlert(Messages.ALE_TASK_EDITING_BUDGE_WIDGET);
			}
			LoadingService.hide();
		} catch (e) {
			LoadingService.hide();
		}
	}

    public async changeTabFrameBudgetInstallmentsIssueClosed() {
		this.changeTabFrameBudgetItensIssueClosed();
	}
}
